package md

type XiaojuGoods struct {
	StoreId      string  `json:"storeId"`
	StoreName    string  `json:"storeName"`
	StoreLogo    string  `json:"storeLogo"`
	CityName     string  `json:"cityName"`
	ProvinceName string  `json:"provinceName"`
	Address      string  `json:"address"`
	Lon          float64 `json:"lon"`
	Lat          float64 `json:"lat"`
	BrandName    string  `json:"brandName"`
	ItemInfoList []struct {
		ItemName   string `json:"itemName"`
		CityPrice  int    `json:"cityPrice"`
		StorePrice int    `json:"storePrice"`
	} `json:"itemInfoList"`
	HuiLabels []string `json:"huiLabels"`
}
type OilStationVipPrice struct {
	StoreId    string `json:"storeId"`
	ItemName   string `json:"itemName"`
	StorePrice int    `json:"storePrice"`
	VipPrice   int    `json:"vipPrice"`
	CityPrice  int    `json:"cityPrice"`
}
type ScreenType struct {
	Name string `json:"name"`
	Type string `json:"type"`
}
type OilReq struct {
	Page      string `json:"page" example:"页码"`
	ItemName  string `json:"item_name" example:"油品 92#"`
	BrandName string `json:"brand_name" example:"品牌"`
	Sort      string `json:"sort" example:"排序"`
	Lat       string `json:"lat" example:"纬度"`
	Lng       string `json:"lng" example:"经度"`
	Keyword   string `json:"keyword"`
}
type OilUrlReq struct {
	IndexId string `json:"index_id" `
	Lat     string `json:"lat" example:"纬度"`
	Lng     string `json:"lng" example:"经度"`
}
type XiaojuGoodsEs struct {
	StoreId      string  `json:"storeId"`
	StoreName    string  `json:"storeName"`
	StoreLogo    string  `json:"storeLogo"`
	CityName     string  `json:"cityName"`
	ProvinceName string  `json:"provinceName"`
	Address      string  `json:"address"`
	Lon          float64 `json:"lon"`
	Lat          float64 `json:"lat"`
	BrandName    string  `json:"brandName"`
	ItemName     string  `json:"itemName"`
	CityPrice    float64 `json:"cityPrice"`
	StorePrice   float64 `json:"storePrice"`
	HuiLabels    string  `json:"huiLabels"`
	IndexId      string  `json:"index_id"`
	Location     struct {
		Lat float64 `json:"lat"`
		Lon float64 `json:"lon"`
	} `json:"location"`
}

const EggOilStation = "zhiying_oil_station"
const EggOilStationMap = `
{ 
	"settings" : {
      "number_of_shards" : 2,
      "number_of_replicas" : 1 
    },
	"mappings":{
		"properties":{
			"lat":{
				"type": "double"
			},
			"lon":{
				"type": "double"
			},
			"platform":{
				"type": "keyword"
			},
			"storeId":{
				"type": "keyword"
			},
			"storeName":{
				"type": "keyword"
			},
			"storeLogo":{
				"type": "keyword"
			},
			"address":{
				"type": "keyword"
			},
			"brandName":{
				"type": "keyword"
			},
			"huiLabels":{
				"type": "keyword"
			},
			"provinceName":{
				"type": "keyword"
			},
			"cityName":{
				"type": "keyword"
			},
			"itemName":{
				"type": "keyword"
			},
			"cityPrice":{
				"type": "double"
			},
			"storePrice":{
				"type": "double"
			},
			"vipPrice":{
				"type": "double"
			},
			"index_id":{
				"type": "keyword"
			},
			"location":{
				"type": "geo_point"
			}
		}
	}
}`
