package svc

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/db/model"
	offical "applet/app/db/official"
	"applet/app/task/md"
	"applet/app/utils"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/xiaoju"
	"encoding/json"
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
	"time"
)

func OilOrder() {
	pvdTimeKey := "oil_time"

	// 获得最后时间
	timeStrData := offical.SysCfgByKey(pvdTimeKey)
	timeStr := ""
	if timeStrData == nil {
		offical.DbsSysCfgInserts(pvdTimeKey, time.Now().Format("2006-01-02"))
		timeStr = offical.SysCfgByKeyStr(pvdTimeKey)
	} else {
		timeStr = timeStrData.V
	}
	// 所有时间都是在操作秒数
	now := time.Now().Unix()
	strs := strings.Split(timeStr, ":")
	if len(strs) == 3 {
		timeStr = strs[0] + ":" + strs[1] + ":00"
	}
	fmt.Println(timeStr)
	past := utils.TimeParseStd(timeStr).Unix()
	// 如果上次记录超过30天或者 过去时间大于当前时间戳, 把时间设置为此前20分钟
	if past < now-180*86400 || past > now {
		past = now
	}
	var (
		beginTime int64 = 0
		endTime   int64 = 0
		pageNo    int   = 1
		pageSize  int   = 50
	)

	//怕时间不是走最新的
	leave := now - past
	if leave > 500 {
		leave = 0
	}
	past = past + leave
	beginTime = past - 85000
	endTime = past

	if endTime > now {
		endTime = now
	}
	for {
		count := 0
		count, _ = OrdersOilGet(pageNo, pageSize, beginTime, endTime)
		if count == 0 {
			goto ChkArg
		}
		// 判断是否分页已经全部取完了
		if count <= pageSize {
			pageNo++
			fmt.Println("========下一页========" + utils.IntToStr(pageNo))
			count = 0
			continue
		}
	ChkArg:
		// 查询完后重置时间, 最后查询时间
		if endTime < now {
			pageNo = 1
			offical.DbsSysCfgUpdate(pvdTimeKey, utils.TimeToStr(endTime))
			beginTime = endTime
			endTime = endTime + 300
			if endTime > now {
				endTime = now
			}
			count = 0
			continue
		}
		count = 0
		break
	}
	offical.DbsSysCfgUpdate(pvdTimeKey, utils.TimeToStr(endTime))

}

func OrdersOilGet(p int, pageSize int, sTime, eTime int64) (int, string) {
	platformKey := XiaojuKey()
	args := map[string]interface{}{
		"queryEndTime":   time.Unix(eTime, 0).Format("2006-01-02 15:04:05"),
		"queryStartTime": time.Unix(sTime, 0).Format("2006-01-02 15:04:05"),
		"pageIndex":      p,
		"pageSize":       pageSize,
	}
	token := GetXiaojuToken(platformKey)
	datas, err := xiaoju.XiaojuStationOrder(platformKey, token, args)
	if err != nil {
		return 0, ""
	}
	var order = make([]md.OilData, 0)
	json.Unmarshal([]byte(gjson.Get(datas, "orderInfoList").String()), &order)
	if len(order) == 0 {
		return 0, ""
	}
	count := len(order)

	for _, v := range order {
		commXiaoju(v)
	}
	return count, ""
}
func commXiaoju(data md.OilData) error {
	if data.PayStatus == 0 {
		return nil
	}
	state := "订单付款"
	if data.RefundStatus == 1 {
		state = "订单退款"
	}
	ex := strings.Split(data.OutUserId, "_")
	if strings.Contains(utils.AnyToString(data.OutUserId), "zhiying") == false {
		return nil
	}
	if strings.Contains(utils.AnyToString(data.OutUserId), "dev") && cfg.Prd {
		return nil
	}
	if strings.Contains(utils.AnyToString(data.OutUserId), "prd") && cfg.Prd == false {
		return nil
	}
	var res = model.LifeOrder{
		PvdParentOid: data.OrderId,
		Pvd:          "xiaoju",
		Status:       state,
		CreateTime:   int(utils.TimeStdParseUnix(data.PayTime)),
	}
	res.Uid = utils.StrToInt(ex[3])
	res.StationUid = utils.StrToInt(ex[2])
	res.Oid = utils.StrToInt64(utils.OrderUUID(utils.StrToInt(ex[2])))
	res.PvdOid = data.OrderId
	res.UpdateTime = int(time.Now().Unix())
	res.Title = data.StoreName
	res.Gid = res.PvdOid
	res.Payment = utils.Float64ToStr(float64(data.RealMoney) / 100)
	var commission = float64(data.RealMoney) / 100 * (0.2 / 100)
	res.Commission = utils.Float64ToStr(commission)
	res.RealCommission = utils.Float64ToStr(commission)
	one := db.GetLifeOrderByOne(res.PvdOid, utils.IntToStr(res.Uid), res.Pvd)
	if one == nil {
		insertOne, err := db.ZhimengDb.InsertOne(&res)
		fmt.Println(insertOne)
		fmt.Println(err)
	} else {
		res.SettleTime = one.SettleTime
		res.CreateTime = one.CreateTime
		if one.PlatformSettleTime > 0 {
			res.PlatformSettleTime = one.PlatformSettleTime
		}
		db.ZhimengDb.Where("id=?", one.Id).AllCols().Update(&res)
	}
	return nil
}
